<template>
  <div class="row">
    <div class="col-6">
      <b-form-group label="Name:">
        <b-form-input
          v-model="create_info.name"
          placeholder="Please enter your name"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-6">
      <b-form-group label="Address:">
        <b-form-input
          v-model="create_info.address"
          placeholder="Please enter your address"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-6">
      <b-form-group label="Avatar URL:">
        <b-form-input
          v-model="create_info.avatarURL"
          placeholder="Please enter your avatarURL"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-6">
      <b-form-group label="Balance:">
        <b-form-input
          v-model="create_info.balance"
          placeholder="Please enter your balance"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-6">
      <b-form-group label="Year of birth:">
        <b-form-input
          v-model="create_info.yearOfBirth"
          placeholder="Please enter your birth year"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-6">
      <b-form-group label="Phone Number:">
        <b-form-input
          v-model="create_info.phoneNumber"
          placeholder="Please enter your phone number"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-6">
      <b-form-group
        label="Email address:"
        description="We'll never share your email with anyone else."
      >
        <b-form-input
          type="email"
          v-model="create_info.email"
          placeholder="Enter email"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-6">
      <b-form-group label="Fax Number:">
        <b-form-input
          v-model="create_info.fax"
          placeholder="Please enter your fax number"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div
      class="col-12"
      style="display: flex; justify-content: right; align-items: right"
    >
      <b-button variant="primary" v-on:click="handleCreateUser"
        >Create new customer</b-button
      >
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: "AddNewCustomerModal",
  props: {
    msg: String,
  },
  data: () => ({
    create_info: {
      id: 0,
      name: "Nguyen Thinh",
      address: "404/28 Nguyen Dinh Chieu",
      avatarURL: "",
      balance: 50000000,
      yearOfBirth: 1994,
      phoneNumber: "0908117036",
      email: "thinh.nguyen@ahasoft.vn",
      fax: "5260070",
      createdDateTimeString: "",
    },
  }),
  methods: {
    async uploadImage() {
      const file = document.querySelector("input[type=file]").files[0];
      const reader = new FileReader();
      let rawImg;
      reader.onloadend = () => {
        rawImg = reader.result;
        // console.log("rawImg = ", rawImg);
        this.create_info.avatarURL = rawImg;
      };
      reader.readAsDataURL(file);
    },
    // validateInfo(phoneNumber){
    //   var phone_regex = /[0]{1}[3789]{1}[0-9]{8}/;
    //   if(phoneNumber.length != 10){
    //     return false;
    //   }
    //   else{
    //     if (phoneNumber.match(phone_regex)){
    //       return true;
    //     }
    //     else{
    //       return fasle;
    //   }
    // },
    validatePhoneNumber(phoneNumber) {
      var phone_regex = /[0]{1}[3789]{1}[0-9]{8}/;
      if (phoneNumber.length != 10 || !phoneNumber.match(phone_regex))
        return false;
      return true;
    },
    validateFaxNumber(faxNumber) {
      var fax_regex = /[1-9]{1}[0-9]{6}/;
      if (faxNumber.length != 7 || !faxNumber.match(fax_regex)) return false;
      return true;
    },
    validateBalance(balance) {
      var balance_regex = /[1-9]{1}[0-9]*/;
      if (!Number(balance) || !String(balance).match(balance_regex))
        return false;
      return true;
    },
    validateEmail(email) {
      var email_regex =
        /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      if (!email.match(email_regex)) return false;
      return true;
    },
    async handleCreateUser() {
      if (!this.validatePhoneNumber(this.create_info.phoneNumber)) {
        alert("Số điện thoại vừa nhập không phù hợp");
      } else if (!this.validateFaxNumber(this.create_info.fax)) {
        alert("Số fax vừa nhập không phù hợp");
      } else if (!this.validateBalance(this.create_info.balance)) {
        alert("Số balance vừa nhập không phù hợp");
      } else if (!this.validateEmail(this.create_info.email)) {
        alert("Email vừa nhập không phù hợp");
      } else {
        var res = await axios.post(
          "https://ahasoft-sample-apis.azurewebsites.net/Customer",
          this.create_info
        );
        console.log(res);
        this.$emit("hideAddNewModal");
        alert("Create user successfully!!!");
        this.$emit("getCustomerList");
      }
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>
